var ischeck = 0;
var isError = 0;
var isAllload = 1;
// app打开，升级，卸装
function appActionClicked(action) {
  jQuery('.apps_alertModle').hide();
  var e = window.event || arguments.callee.caller.arguments[0];
  e.stopPropagation();

  var appNode;
  appNode = jQuery(e.currentTarget).closest('div.apps_items');
  if (appNode.length === 0) {
    appNode = jQuery(e.currentTarget).closest('tr.apps_item');
  }
  var packagename = appNode.attr('packagename');
  var appname = appNode.attr('appname');

  if (action == 'open') {
    UNAS.StartApp(appname);
  } else {
    clearTimeout(progress_timeout);
    appManagerInstallApp(packagename, action, appname);
  }

}

// 1.安装app, 2.升级app, 4.卸装app
function appManagerInstallApp(packagename, action, appname) {

  var actiontype = {
    install: 1,
    upgrade: 2,
    remove: 4
  }
  var app_item = jQuery('#app_item_' + packagename);
  app_item.find('.percent_txt').text('0%');
  app_item.find('.percent_bar_inner').css('width', '0px');

  app_item.find('.apps_actions').addClass('disabled-btn');
  app_item.find('.retry').addClass('disabled-btn');
  jQuery.ajax({
    url: '/wmi/index.php',
    type: 'POST',
    async: true,
    dataType: 'json',
    contentType: 'application/json;charset=utf-8',
    data: JSON.stringify({
      cmd: 'installer_execute',
      token: UToken,
      params: {
        action: actiontype[action],
        package: packagename
      }
    }),
    success: function(data) {
      // console.log(data);
      if (data.err == 0) {
        app_item.find('.apps_operate_status').text(UNAS._('##$@appmanager@$##Added to task list##$@appmanager@$##'));
        if (action == 'remove' || action == 'upgrade') {
          callAppUninstallFunc(appname);
        }
        app_item.find('.apps_operate_info').show();
        app_item.find('.apps_actions').hide();
        app_item.find('.retry').hide();
        loadAppProgress();
      } else if (data.err == 9958) {
        appinstallerrmsg('System error, please try again later.');
      } else if (data.err == 9951) {
        appinstallerrmsg("##$@desktop@$##Device authentication failed. Please make sure this is a legal device.##$@desktop@$##", true);
      }
    },
    complete: function(XMLHttpRequest, textStatus) {
      app_item.find('.apps_actions').removeClass('disabled-btn');
      app_item.find('.retry').removeClass('disabled-btn');
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });
}

window.appmanager.onClose = function() {
  clearTimeout(progress_timeout);
};
//检测app安装/升级/卸载中进度
function loadAppProgress() {
  clearTimeout(progress_timeout);
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: '/wmi/index.php',
      type: 'POST',
      async: true,
      dataType: 'json',
      timeout: 60000,
      contentType: 'application/json;charset=utf-8',
      data: JSON.stringify({
        cmd: 'apps_executing',
        token: UToken
      }),
      success: function(data) {
        // console.log(data);
        tmpApps = [];
        for (var i = 0; i < UNAS.Apps.length; i++) {
          tmpApps.push(UNAS.Apps[i].appName);
        }
        var progressInfo = data.results || {};
        if (data.err == 0) {
          var apps_progress = progressInfo.packages || [];
          for (var i = 0; i < apps_progress.length; i++) {
            var app_progress_info = apps_progress[i];

            if (app_progress_info.exec) {
              app_progress_info['stateinfo'] = appExecCodeMsg[app_progress_info.exec];
            } else {
              app_progress_info['stateinfo'] = appStepCodeMsg[app_progress_info.state];
            }

            updateAppState(app_progress_info.state, app_progress_info);
          }

          if (progressInfo.state == 30) {

            isError = 0;
          }

          progress_timeout = setTimeout('loadAppProgress()', 2000);

          if (progressInfo.reboot) {
            restartSystem()
          }

          if (progressInfo.catalog) {
            var upgradables = progressInfo.catalog.upgradables || 0;
            if (upgradables) {
              jQuery("#jv-upgrad-total").html(upgradables).show();
            } else {
              jQuery("#jv-upgrad-total").hide();
            }
          } else {
            var upgradables = 0;
            for (var i = 0; i < appInfos.length; i++) {
              var appdata = appInfos[i];
              if (+appInfos[i].upgradable) {
                upgradables++;
              }
            }

            if (upgradables) {
              jQuery("#jv-upgrad-total").html(upgradables).show();
            } else {
              jQuery("#jv-upgrad-total").hide();
            }
          }


        } else if (data.err == 9972) {
          isError++;
          if (isError < 6) {
            progress_timeout = setTimeout('loadAppProgress()', 2000);
          } else {
            clearTimeout(progress_timeout);
            isError = 0;
          }

        } else {
          // clearTimeout(progress_timeout);
        }

      },
      complete: function(XMLHttpRequest, textStatus) {
        if (textStatus == 'timeout') {
          loadAppProgress();
        }
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        console.log('error while requesting progress.');
      }
    });
  })

}

// 更新app状态
function updateAppState(step, appProgressInfo) {
  // console.log(step);
  // console.log(appProgressInfo);
  var app_item = jQuery('#app_item_' + appProgressInfo.package);
  var version = appProgressInfo.version || '';
  var appname = getappname(appnamelist, appProgressInfo.package);
  var statuTxt = getAppmanagerText(appProgressInfo.stateinfo);

  setAppUpgradpercent(appProgressInfo, app_item, (statuTxt || ''));

  if (appProgressInfo.exec == 20) {

    if (appProgressInfo.action != 4) {

      if (appProgressInfo.action == 1) {

        for (var i = 0; i < allappinfo.length; i++) {
          if (allappinfo[i].appname == appname && allappinfo[i].version == version) {
            allappinfo[i].installed = 1;
            break;
          }
        }

        if (tmpApps.indexOf(appname) <= -1) {
          clearTimeout(progress_timeout);
          UNAS.LoadApp(appname, function() {
            UNAS.AddMenuPanel(appname);
            if (step) {
              loadAppProgress();
            }
          });
          try {
            UNAS.SaveUserDesktop();
          } catch (err) {}
        }

      } else if (appProgressInfo.action == 2) {

        if (appname) {
          for (var i = 0; i < allappinfo.length; i++) {
            if (allappinfo[i].appname == appname && allappinfo[i].version == version) {
              allappinfo[i].upgradable = 0;
              break;
            }
          }


          if (appProgressInfo.package == "appmanager-unas") {
            MUI.updateContent({
              element: $('AppManagerAppWindow'),
              url: '/apps/appmanager/appmanager.html?v=6.0.62&'
            });
          }

          if (tmpApps.indexOf(appname) <= -1) {
            clearTimeout(progress_timeout);
            UNAS.LoadApp(appname, function() {
              UNAS.AddMenuPanel(appname);
              if (step) {
                loadAppProgress();
              }
            });
          }

        }

      }

      app_item.find('.app_open').show();
      app_item.find('.app_remove').show();
      app_item.find('.Privilegebtn').show();
    } else {
      app_item.find('.Privilegebtn').hide();
      app_item.find('.app_open').hide();
      app_item.find('.app_remove').hide();

      for (var i = 0; i < allappinfo.length; i++) {
        if (allappinfo[i].appname == appname) {
          allappinfo[i].installed = 0;
        }
      }

    }

    for (var i = 0; i < allappinfo.length; i++) {
      if (allappinfo[i].appname == appname) {
        var action = allappinfo[i].installed === 0 ? 'noinstall' : (allappinfo[i].upgradable === 0 ? 'installed' : 'update');
        if (allappinfo[i].installed && !allappinfo[i].upgradable) {
          app_item.find('.Upgradebtn').hide();
          app_item.find('.Installbtn').hide();
          app_item.find('.Openbtn').show();
          app_item.find('.Privilegebtn').show();
        } else if (allappinfo[i].installed && allappinfo[i].upgradable) {
          app_item.find('.Upgradebtn').show();
          app_item.find('.Installbtn').hide();
          app_item.find('.Openbtn').show();
          app_item.find('.Privilegebtn').show();
        } else if (!allappinfo[i].installed) {
          app_item.find('.Upgradebtn').hide();
          app_item.find('.Installbtn').show();
          app_item.find('.Openbtn').hide();
          app_item.find('.Privilegebtn').hide();
        }
        app_item.find('.appstaimg').attr('src', '/apps/appmanager/images/app_bg_' + action + '.png?v=6.0.62');
        break;
      }

    }

    upappItemTranslator('app_item_' + appProgressInfo.package);

  } else {

    // app_item.find('.apps_operate_info').show();
    // app_item.find('.apps_actions').hide();
    //
    // var actionType = {
    //   1 : 'Installing',
    //   2 : 'Upgrading',
    //   4 : 'Uninstalling'
    // }

  }



  if (typeof appmanagerDetailUpdateBooth === 'function') {
    appmanagerDetailUpdateBooth(appProgressInfo, step, statuTxt);
  }

  setappstate(allappinfo);

}

// 设置进度条
function setAppUpgradpercent(appProgressInfo, app_item, statuTxt) {
  let w = appListViewModel == 'line' ? 168 : 227;
  var rate = appProgressInfo.rate || 0;
  app_item.find('.percent_bar').css('width', w + 'px');
  app_item.find('.percent_bar_inner').css('width', rate + '%');
  app_item.find('.apps_operate_status').text(UNAS._(statuTxt));
  app_item.find('.percent_txt').text(rate + '%');

  if (appProgressInfo.exec == 20) {
    app_item.find('.apps_operate_info').hide();
    app_item.find('.apps_actions').show();
  } else if (appProgressInfo.exec == 15) {
    setTimeout(function() {
      app_item.find('.apps_operate_info').hide();
      app_item.find('.apps_actions').hide();
      app_item.find('.retry').show().attr('action', appProgressInfo.action).on('click', function() {
        var action = +jQuery(this).attr('action');
        appActionClicked(action);
      });
    }, 500)
  } else {
    app_item.find('.apps_operate_info').show();
    app_item.find('.apps_actions').hide();
  }

}
//刷新
function refreshAppsList() {
  clearTimeout(progress_timeout);
  appInfos = appAssort[curtype];

  if (isAllload) {
    loadAppList().then(function() {
      loadAppProgress();
    });
  } else {
    initAppGallery(AppsObjModeSort(jQuery(".asOrDescending.actived")[0].id, jQuery(".sortModeType.actived")[0].id, appInfos), function() {
      loadAppProgress();
    });
  }
}

// app更多详情下拉选项
function showShortcutMenu() {
  var e = window.event || arguments.callee.caller.arguments[0];
  e.stopPropagation();
  jQuery(e.currentTarget).parents('.apps_item').siblings().find('.apps_alertModle').hide();
  jQuery(e.currentTarget).find('.apps_alertModle').toggle();
  var curindex = jQuery(e.currentTarget).parents('.apps_item').index();
  var trlen = jQuery('#appmanager_appslist tr').length;
  if ((trlen - curindex) < 3) {
    jQuery(e.currentTarget).find('.apps_alertModle').css({
      top: 'auto',
      bottom: '30px'
    })
  }
}

//点击显示下拉选项
function showAlertModle_top(type) {
  let event = window.event || arguments.callee.caller.arguments[0];
  event.stopPropagation();
  var currentTarget = jQuery(event.currentTarget);
  currentTarget.siblings().find('.apps_alertModle').hide();
  currentTarget.find('.apps_alertModle').toggle();

  currentTarget.find('.apps_alertModle .modleList').each(function(i, e) {
    e.onclick = function() {
      switch (type) {
        case 'sort':
          AppsChangeSortMode(e);
          break;
        case 'mode':
          //浏览模式切换
          appListViewModel = e.id;
          var img = appListViewModel == 'item' ? 'apps_item' : 'browse_mode';
          jQuery('#jv-modetype').attr('src', '/apps/appmanager/images/' + img + '.png?v=6.0.62&');
          appPageTranslator('jv-modetype');
          jQuery(e).addClass('actived').siblings().removeClass("actived");
          initAppGallery(appInfos, function() {
            loadAppProgress();
          });
          break;
        default:
      }
    }
  })
}


//排序方式切换
function AppsChangeSortMode(e) {
  var jTgt = jQuery(e);
  //更改样式函数
  this.changeClass = function(c) {
    var siblings = jTgt.siblings(c);
    for (var i = 0; i < siblings.length; i++) {
      siblings.eq(i).removeClass("actived");
    }
    jTgt.addClass("actived");
  };

  if (jTgt.hasClass("asOrDescending")) {
    this.changeClass(".asOrDescending");
    var sortAttr = jTgt.siblings(".actived")[0].id; //排序的属性
    var ord = jTgt[0].id; //升序或降序
    initAppGallery(AppsObjModeSort(ord, sortAttr, appInfos));
  } else if (jTgt.hasClass("sortModeType")) {
    this.changeClass(".sortModeType");
    var ord = jTgt.siblings(".actived")[0].id; //升序或降序
    var sortAttr = jTgt[0].id; //排序的属性
    initAppGallery(AppsObjModeSort(ord, sortAttr, appInfos));
  }
}


// 左边导航
jQuery('#appmanager_title_table_list .appmanager_appclass').each(function(i, e) {
  e.onclick = function() {
    var type = jQuery(this).attr("apptype");
    curtype = jQuery(this).attr("apptype");
    // appmanagerShowWaiting();
    jQuery(this).addClass('appmanager_table_tr_on').siblings().removeClass('appmanager_table_tr_on');
    clearTimeout(progress_timeout);
    appInfos = appAssort[curtype];

    if (isAllload) {
      loadAppList().then(function() {
        loadAppProgress();
      });
    } else {
      initAppGallery(AppsObjModeSort(jQuery(".asOrDescending.actived")[0].id, jQuery(".sortModeType.actived")[0].id, appInfos), function() {
        loadAppProgress();
      });
    }


  }
})


function refresh_apps_loadby(type) {

  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: "/wmi/index.php",
      type: "POST",
      async: true,
      dataType: 'json',
      data: JSON.encode({
        "cmd": "apps_loadby",
        "token": UToken,
        "params": {
          "type": type
        }
      }),
      success: function(data) {
        if (data.err == 0) {
          appInfos = data.results.apps[0].AppsInfo;
          initAppGallery(AppsObjModeSort(jQuery(".asOrDescending.actived")[0].id, jQuery(".sortModeType.actived")[0].id, appInfos));
          resolve(data);
          if (type == 'upgradable') {
            upgradTotal = 0;
            for (var i = 0; i < appInfos.length; i++) {
              if (+appInfos[i].upgradable) {
                upgradTotal++;
              }
            }
            if (upgradTotal) {
              jQuery("#jv-upgrad-total").html(upgradTotal).show();
            } else {
              jQuery("#jv-upgrad-total").hide();
            }
          }
        } else {
          appmanagerHideWaiting();
          if (data.err == 9971) {
            jQuery('#jv-onLine').show();
            jQuery("#appmanager_appslist").hide();
          }
        }
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        //console.log('appmanager apps_loadby error textStatus:' + textStatus);
      },
      complete: function() {
        appmanagerHideWaiting();
      }
    });
  })
}
//手动安装（弹框）
function manualInstall() {
  MUI.ManualInstallWindow = function() {
    new MUI.Modal({
      id: 'ManualInstallWindow',
      title: UNAS._('Manual Install'),
      contentURL: '/apps/appmanager/appmanager_manualinstall.html?v=6.0.62&',
      modalOverlayClose: false,
      width: 660,
      height: 440,
      modal: true
    });
  };
  MUI.ManualInstallWindow();
}

//恢复备份
function appmanagerShowBackupList() {
  showWindowMirror();
}
//恢复备份(弹窗)
function showWindowMirror() {
  var _modelWindow = new MUI.Modal({
    id: 'appmanagerWindowMirror',
    title: UNAS._('##$@appmanager@$##Restore Backup##$@appmanager@$##'),
    contentURL: '/apps/appmanager/appmanager_mirror.html?v=6.0.62&',
    modal: true,
    modalOverlayClose: false,
    width: 660,
    height: 380
  });
}

//权限（弹框）
function SetupAppAccountPrivilege() {
  jQuery('.apps_alertModle').hide();
  var e = window.event || arguments.callee.caller.arguments[0];
  e.stopPropagation();

  var appNode;
  appNode = jQuery(e.currentTarget).closest('div.apps_items');
  if (appNode.length === 0) {
    appNode = jQuery(e.currentTarget).closest('tr.apps_item');
  }
  var packagename = appNode.attr('packagename');
  var appname = appNode.attr('appname');

  var SetupAppAccountPrivilegeWindow = new MUI.Modal({
    id: 'SetupAppAccountPrivilegeWindow',
    title: UNAS._('App Privilege Setup'),
    contentURL: '/apps/appmanager/appmanager_appprivilege.html?v=6.0.62&apppkgname=' + packagename + '&appname=' + appname,
    modalOverlayClose: false,
    width: 700,
    height: 480,
    modal: true
  });
  SetupAppAccountPrivilegeWindow.ProcessAppPrivilege = function() {};
}

//app详情
function appManagerShowDetail() {
  jQuery('.apps_alertModle').hide();
  var e = window.event || arguments.callee.caller.arguments[0];
  e.stopPropagation();
  var appNode;
  appNode = jQuery(e.currentTarget).closest('div.apps_items');
  if (appNode.length === 0) {
    appNode = jQuery(e.currentTarget).closest('tr.apps_item');
  }
  var packagename = appNode.attr('packagename');

  var _modelWindow = new MUI.Modal({
    id: 'appmanagerWindowAppDetails',
    title: UNAS._('Details'),
    contentURL: '/apps/appmanager/appmanager_appdetails.html?packagename=' + packagename,
    modalOverlayClose: false,
    width: 660,
    height: 440,
    modal: true,
    onClose: function() {
      if (typeof onCloseAppDetails === 'function') {
        onCloseAppDetails();
        onCloseAppDetails = null;
      }
    }
  });
}

function appinstallerrmsg(errinfo, type) {
  var text = UNAS._('##$@appmanager@$##' + errinfo + '##$@appmanager@$##');
  if (type) {
    text = UNAS._(errinfo);
  }
  var _uninstallWindow = new MUI.Modal({
    id: 'appmanagerWindowConfirmMsg',
    title: UNAS._('##$@appmanager@$##Notice##$@appmanager@$##'),
    contentURL: '/apps/appmanager/appmanager_msg_confirm.html?v=6.0.62&text=' + text,
    modal: true,
    modalOverlayClose: false,
    width: 500,
    height: 200
  });
  _uninstallWindow.callBack = function() {

  };
}
